#version 110
#info squary 3D Koch  Distance Estimator.
#include "DE-Raytracer.frag"
#include "MathUtils.frag"
#group sqKoch 
// Based on Knighty's Kaleidoscopic IFS 3D Fractals, described here:
// http://www.fractalforums.com/3d-fractal-generation/kaleidoscopic-%28escape-time-ifs%29/

// Number of iterations.
uniform int Iterations;  slider[0,6,100]

// Scale parameter. A perfect Menger is 3.0
uniform float Scale; slider[0.00,3,4.00]

uniform vec3 RotVector; slider[(0,0,0),(1,0,0),(1,1,1)]

// Scale parameter. A perfect Menger is 3.0
uniform float RotAngle; slider[0,0,360]

mat3 rot;

void init() {
	 rot = rotationMatrix3(normalize(RotVector), RotAngle);
}

float DE(vec3 z)
{
	float r;
	int n = 0;
	vec3 c=vec3(0.);
while (n < Iterations && dot(z,z)<10.0) {
		// Fold
		z = abs(z);
		if(z.y>z.x) z.xy=z.yx;
		if(z.z>z.y) z.yz=z.zy;
		if(z.y>z.x) z.xy=z.yx;

		float d0=dot(z-vec3(4./3.,0.,0.),z-vec3(4./3.,0.,0.));
		float d1=dot(z-vec3(2./3.,2./3.,0.),z-vec3(2./3.,2./3.,0.));
		float d2=dot(z-vec3(2./3.,2./3.,2./3.),z-vec3(2./3.,2./3.,2./3.));
		float d=min(min(d0,d1),d2);
		if(d==d0) c=vec3(2.,0.,0.);
		else if(d==d1) c=vec3(1.,1.,0.);
		else if(d==d2) c=vec3(1.,1.,1.);
		//z = rot *z;
		z=Scale* (z-c)+c;
		z = rot *z;
		
		r = dot(z, z);
		orbitTrap = min(orbitTrap, abs(vec4(z,r)));
		
		n++;
	}
	return (length(z)-2.) * pow(Scale, float(-n));
	//z=abs(z)-vec3(1.); return max(z.x,max(z.y,z.z)) * pow(Scale, float(-n));
}

